#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QGraphicsRectItem>
#include <QGraphicsEllipseItem>

#include "myrectangle.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    setup ();
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::setup ()
{
    QGraphicsScene * scene = new QGraphicsScene ();
    ui->graphicsView->setScene (scene);

    scene->addLine(10, 10, 100, 100);
    scene->addRect(100, 10, 20, 20);
    scene->addEllipse(140, 20, 40, 70);

    MyRectangle * r = new MyRectangle;
    r->setPen(QColor ("red"));
    r->setBrush(QColor ("yellow"));
    r->setRect (100, 100, 100, 100);
    r->setFlags(QGraphicsItem::ItemIsMovable);
    scene->addItem (r);


    for (int i = 1; i <= 2; i++)
    {
    QGraphicsEllipseItem * e = new QGraphicsEllipseItem;
    e->setPen(QColor ("orange"));
    e->setBrush(QColor ("green"));
    e->setParentItem (r);
    e->setRect (70 + 40*i, 120, 20, 20);
    }

    showScene (scene);
}

void MainWindow::showScene (QGraphicsScene * scene)
{
    QList < QGraphicsItem * > list = scene->items ();
    int cnt = list.count ();
    for (int i = 0 ; i < cnt; i++)
    {
        QGraphicsItem * p = list.value (i);
        if (p->parentItem() == NULL)
            showBranch (NULL, p);
    }
}

void MainWindow::showBranch (QTreeWidgetItem * above, QGraphicsItem * item)
{
    QTreeWidgetItem * t = new QTreeWidgetItem;

    QString s = "something";

    QGraphicsRectItem * r = dynamic_cast < QGraphicsRectItem * > (item);
    if (r != NULL)
        s = "rectangle " + QString::number ( r->rect().x() ) +
             ", " + QString::number ( r->rect().y() );

    MyRectangle * m = dynamic_cast < MyRectangle * > (item);
    if (m != NULL)
        s = m->info ();

    t->setText (0, s);

    if (above == NULL)
        ui->treeWidget->addTopLevelItem(t);
    else
        above->addChild (t);


    QList < QGraphicsItem * > list = item->childItems();
    int cnt = list.count ();
    for (int i = 0 ; i < cnt; i++)
        showBranch (t, list[i]);
}

